Index: TvEngine3/TVLibrary/SetupTv/Sections/TvChannelMapping.Designer.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Sections/TvChannelMapping.Designer.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/Sections/TvChannelMapping.Designer.cs	(working copy)
@@ -72,7 +72,7 @@
       this.tabControl1.Name = "tabControl1";
       this.tabControl1.SelectedIndex = 0;
       this.tabControl1.Size = new System.Drawing.Size(454, 392);
-      this.tabControl1.TabIndex = 18;
+      this.tabControl1.TabIndex = 0;
       // 
       // tabPage1
       // 
@@ -103,7 +103,7 @@
       this.mpCheckBoxMapForEpgOnly.Location = new System.Drawing.Point(6, 343);
       this.mpCheckBoxMapForEpgOnly.Name = "mpCheckBoxMapForEpgOnly";
       this.mpCheckBoxMapForEpgOnly.Size = new System.Drawing.Size(355, 17);
-      this.mpCheckBoxMapForEpgOnly.TabIndex = 27;
+      this.mpCheckBoxMapForEpgOnly.TabIndex = 6;
       this.mpCheckBoxMapForEpgOnly.Text = "Perform mapping for EPG grabbing only (you can also use doubleclick)";
       this.mpCheckBoxMapForEpgOnly.UseVisualStyleBackColor = true;
       // 
@@ -122,7 +122,7 @@
       this.mpButtonUnmap.Location = new System.Drawing.Point(211, 103);
       this.mpButtonUnmap.Name = "mpButtonUnmap";
       this.mpButtonUnmap.Size = new System.Drawing.Size(27, 23);
-      this.mpButtonUnmap.TabIndex = 25;
+      this.mpButtonUnmap.TabIndex = 4;
       this.mpButtonUnmap.Text = "<<";
       this.mpButtonUnmap.UseVisualStyleBackColor = true;
       this.mpButtonUnmap.Click += new System.EventHandler(this.mpButtonUnmap_Click);
@@ -132,7 +132,7 @@
       this.mpButtonMap.Location = new System.Drawing.Point(211, 74);
       this.mpButtonMap.Name = "mpButtonMap";
       this.mpButtonMap.Size = new System.Drawing.Size(27, 23);
-      this.mpButtonMap.TabIndex = 24;
+      this.mpButtonMap.TabIndex = 3;
       this.mpButtonMap.Text = ">>";
       this.mpButtonMap.UseVisualStyleBackColor = true;
       this.mpButtonMap.Click += new System.EventHandler(this.mpButtonMap_Click);
@@ -145,7 +145,7 @@
       this.mpLabel3.Location = new System.Drawing.Point(250, 32);
       this.mpLabel3.Name = "mpLabel3";
       this.mpLabel3.Size = new System.Drawing.Size(131, 13);
-      this.mpLabel3.TabIndex = 23;
+      this.mpLabel3.TabIndex = 0;
       this.mpLabel3.Text = "Channels mapped to card:";
       // 
       // mpListViewMapped
@@ -163,11 +163,11 @@
       this.mpListViewMapped.Name = "mpListViewMapped";
       this.mpListViewMapped.Size = new System.Drawing.Size(193, 290);
       this.mpListViewMapped.SmallImageList = this.imageList1;
-      this.mpListViewMapped.TabIndex = 22;
+      this.mpListViewMapped.TabIndex = 5;
       this.mpListViewMapped.UseCompatibleStateImageBehavior = false;
       this.mpListViewMapped.View = System.Windows.Forms.View.Details;
+      this.mpListViewMapped.ColumnClick += new System.Windows.Forms.ColumnClickEventHandler(this.mpListViewMapped_ColumnClick);
       this.mpListViewMapped.DoubleClick += new System.EventHandler(this.mpListViewMapped_DoubleClick);
-      this.mpListViewMapped.ColumnClick += new System.Windows.Forms.ColumnClickEventHandler(this.mpListViewMapped_ColumnClick);
       // 
       // columnHeader2
       // 
@@ -180,7 +180,7 @@
       this.mpLabel2.Location = new System.Drawing.Point(0, 32);
       this.mpLabel2.Name = "mpLabel2";
       this.mpLabel2.Size = new System.Drawing.Size(99, 13);
-      this.mpLabel2.TabIndex = 21;
+      this.mpLabel2.TabIndex = 0;
       this.mpLabel2.Text = "Available channels:";
       // 
       // mpListViewChannels
@@ -197,7 +197,7 @@
       this.mpListViewChannels.Name = "mpListViewChannels";
       this.mpListViewChannels.Size = new System.Drawing.Size(193, 290);
       this.mpListViewChannels.SmallImageList = this.imageList1;
-      this.mpListViewChannels.TabIndex = 20;
+      this.mpListViewChannels.TabIndex = 2;
       this.mpListViewChannels.UseCompatibleStateImageBehavior = false;
       this.mpListViewChannels.View = System.Windows.Forms.View.Details;
       this.mpListViewChannels.ColumnClick += new System.Windows.Forms.ColumnClickEventHandler(this.mpListViewChannels_ColumnClick);
@@ -213,7 +213,7 @@
       this.mpLabel1.Location = new System.Drawing.Point(42, 9);
       this.mpLabel1.Name = "mpLabel1";
       this.mpLabel1.Size = new System.Drawing.Size(32, 13);
-      this.mpLabel1.TabIndex = 19;
+      this.mpLabel1.TabIndex = 0;
       this.mpLabel1.Text = "Card:";
       // 
       // mpComboBoxCard
@@ -225,7 +225,7 @@
       this.mpComboBoxCard.Location = new System.Drawing.Point(80, 6);
       this.mpComboBoxCard.Name = "mpComboBoxCard";
       this.mpComboBoxCard.Size = new System.Drawing.Size(360, 21);
-      this.mpComboBoxCard.TabIndex = 18;
+      this.mpComboBoxCard.TabIndex = 1;
       this.mpComboBoxCard.SelectedIndexChanged += new System.EventHandler(this.mpComboBoxCard_SelectedIndexChanged);
       // 
       // mpLabelChannelCount
@@ -234,7 +234,7 @@
       this.mpLabelChannelCount.Location = new System.Drawing.Point(13, 14);
       this.mpLabelChannelCount.Name = "mpLabelChannelCount";
       this.mpLabelChannelCount.Size = new System.Drawing.Size(0, 13);
-      this.mpLabelChannelCount.TabIndex = 2;
+      this.mpLabelChannelCount.TabIndex = 0;
       // 
       // TvChannelMapping
       // 
Index: TvEngine3/TVLibrary/SetupTv/Sections/TVChannels.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Sections/TVChannels.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/Sections/TVChannels.cs	(working copy)
@@ -20,13 +20,11 @@
 
 using System;
 using System.Collections.Generic;
-using System.Text;
 using System.Windows.Forms;
 using SetupTv.Dialogs;
 using TvControl;
 using Gentle.Framework;
 using TvDatabase;
-using TvLibrary.Log;
 using TvLibrary.Interfaces;
 using MediaPortal.UserInterface.Controls;
 using System.Threading;
@@ -79,6 +77,7 @@
       : base(name)
     {
       InitializeComponent();
+
       lvwColumnSorter = new MPListViewStringColumnSorter();
       lvwColumnSorter.Order = SortOrder.None;
       lvwColumnSorter2 = new MPListViewStringColumnSorter();
@@ -123,13 +122,13 @@
         TabPage page = new TabPage(group.GroupName);
         page.SuspendLayout();
 
-        ChannelsInGroupControl channelsInRadioGroupControl = new ChannelsInGroupControl();
-        channelsInRadioGroupControl.Location = new System.Drawing.Point(9, 9);
-        channelsInRadioGroupControl.Anchor = ((AnchorStyles.Top | AnchorStyles.Bottom)
+        ChannelsInGroupControl channelsInGroupControl = new ChannelsInGroupControl();
+        channelsInGroupControl.Location = new System.Drawing.Point(9, 9);
+        channelsInGroupControl.Anchor = ((AnchorStyles.Top | AnchorStyles.Bottom)
                                               | AnchorStyles.Left)
                                              | AnchorStyles.Right;
 
-        page.Controls.Add(channelsInRadioGroupControl);
+        page.Controls.Add(channelsInGroupControl);
 
         page.Tag = group;
         page.Location = new System.Drawing.Point(4, 22);
@@ -375,7 +374,6 @@
         //mpListView1.Items[i].Text = (i + 1).ToString();
 
         Channel channel = (Channel)mpListView1.Items[i].Tag;
-
         if (channel.SortOrder != i)
         {
           channel.SortOrder = i;
Index: TvEngine3/TVLibrary/SetupTv/Sections/TvEpgGrabber.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Sections/TvEpgGrabber.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/Sections/TvEpgGrabber.cs	(working copy)
@@ -21,12 +21,11 @@
 using System;
 using System.Collections.Generic;
 using System.Windows.Forms;
-using TvControl;
-using Gentle.Framework;
 using TvDatabase;
 using TvLibrary.Log;
 using TvLibrary.Interfaces;
 using MediaPortal.UserInterface.Controls;
+using SetupTv.Sections.Helpers;
 
 namespace SetupTv.Sections
 {
@@ -108,139 +107,48 @@
     public override void OnSectionActivated()
     {
       mpListView1.BeginUpdate();
+      base.OnSectionActivated();
+      mpListView1.Items.Clear();
+      List<ListViewItem> items = new List<ListViewItem>();
       try
       {
         LoadLanguages();
         TvBusinessLayer layer = new TvBusinessLayer();
         Setting setting = layer.GetSetting("epgStoreOnlySelected");
         mpCheckBoxStoreOnlySelected.Checked = (setting.Value == "yes");
-        Dictionary<string, CardType> cards = new Dictionary<string, CardType>();
-        IList<Card> dbsCards = Card.ListAll();
-        foreach (Card card in dbsCards)
-        {
-          cards[card.DevicePath] = RemoteControl.Instance.Type(card.IdCard);
-        }
-        base.OnSectionActivated();
-        mpListView1.Items.Clear();
 
-        SqlBuilder sb = new SqlBuilder(StatementType.Select, typeof(Channel));
-        sb.AddOrderByField(true, "sortOrder");
-        SqlStatement stmt = sb.GetStatement(true);
-        IList<Channel> channels = ObjectFactory.GetCollection<Channel>(stmt.Execute());
+        IDictionary<int, IList<ChannelMap>> dChannelMaps = ChannelListHelper.GetDictionaryOfChannelMaps(ChannelType.Tv);
+        IDictionary<int, IList<TuningDetail>> dTuningDetails = ChannelListHelper.GetDictionaryOfTuningDetailsForGroup(-1, ChannelType.Tv);
+        IDictionary<int, CardType> dCardTypes = ChannelListHelper.GetDictionaryOfInstalledCardTypes();
 
+        IList<TuningDetail> tuningDetails;
+        IList<ChannelMap> maps;
+        IList<Channel> channels = ChannelListHelper.GetChannelsOfTypeForGroup(-1, ChannelType.Tv);
         foreach (Channel ch in channels)
         {
-          bool analog = false;
-          bool dvbc = false;
-          bool dvbt = false;
-          bool dvbs = false;
-          bool atsc = false;
-          bool dvbip = false;
-          bool hasFta = false;
-          bool hasScrambled = false;         
-          if (ch.IsTv == false)
+          dTuningDetails.TryGetValue(ch.IdChannel, out tuningDetails);
+
+          if (ChannelListHelper.HasWebstreamTuningDetails(tuningDetails))
             continue;
-          if (ch.IsWebstream())
-            continue;
+          int imageIndex = ChannelListIcons.GetChannelListIconIndex(ch, tuningDetails);
+          ListViewItem item = new ListViewItem(ch.DisplayName, imageIndex);
+          items.Add(item);
 
-          IList<TuningDetail> tuningDetails = ch.ReferringTuningDetail();
-          foreach (TuningDetail detail in tuningDetails)
-          {
-            if (detail.FreeToAir)
-            {
-              hasFta = true;
-            }
-            if (!detail.FreeToAir)
-            {
-              hasScrambled = true;
-            }
-          }
+          dChannelMaps.TryGetValue(ch.IdChannel, out maps);
+          string MappingNames = ChannelListHelper.GetMappingNames(maps, dCardTypes, tuningDetails);
 
-          int imageIndex;
-          if (hasFta && hasScrambled)
-          {
-            imageIndex = 5;
-          }
-          else if (hasScrambled)
-          {
-            imageIndex = 4;
-          }
-          else
-          {
-            imageIndex = 3;
-          }
-
-          ListViewItem item = mpListView1.Items.Add(ch.DisplayName, imageIndex);
-          foreach (ChannelMap map in ch.ReferringChannelMap())
-          {
-            if (cards.ContainsKey(map.ReferencedCard().DevicePath))
-            {
-              CardType type = cards[map.ReferencedCard().DevicePath];
-              switch (type)
-              {
-                case CardType.Analog:
-                  analog = true;
-                  break;
-                case CardType.DvbC:
-                  dvbc = true;
-                  break;
-                case CardType.DvbT:
-                  dvbt = true;
-                  break;
-                case CardType.DvbS:
-                  dvbs = true;
-                  break;
-                case CardType.Atsc:
-                  atsc = true;
-                  break;
-                case CardType.DvbIP:
-                  dvbip = true;
-                  break;
-              }
-            }
-          }
-          string line = "";
-          if (analog)
-          {
-            line += "Analog";
-          }
-          if (dvbc)
-          {
-            if (line != "")
-              line += ",";
-            line += "DVB-C";
-          }
-          if (dvbt)
-          {
-            if (line != "")
-              line += ",";
-            line += "DVB-T";
-          }
-          if (dvbs)
-          {
-            if (line != "")
-              line += ",";
-            line += "DVB-S";
-          }
-          if (atsc)
-          {
-            if (line != "")
-              line += ",";
-            line += "ATSC";
-          }
-          if (dvbip)
-          {
-            if (line != "")
-              line += ",";
-            line += "DVB-IP";
-          }
-          item.SubItems.Add(line);
+          item.SubItems.Add(MappingNames);
           item.Checked = ch.GrabEpg;
           item.Tag = ch;
         }
       }
+      catch (Exception exp)
+      {
+        Log.Error("SetupTV.TvEpgGrabber.OnSectionActivated error: {0}", exp.StackTrace);
+      }
       finally
       {
+        mpListView1.Items.AddRange(items.ToArray());
         mpListView1.EndUpdate();
       }
     }
Index: TvEngine3/TVLibrary/SetupTv/SetupTv.csproj
===================================================================
--- TvEngine3/TVLibrary/SetupTv/SetupTv.csproj	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/SetupTv.csproj	(working copy)
@@ -214,6 +214,7 @@
     <Compile Include="Sections\Epg.Designer.cs">
       <DependentUpon>Epg.cs</DependentUpon>
     </Compile>
+    <Compile Include="Sections\Helpers\ChannelListHelper.cs" />
     <Compile Include="Sections\Helpers\ChannelListViewHandler.cs" />
     <Compile Include="Sections\TestChannels.cs">
       <SubType>UserControl</SubType>
Index: TvEngine3/TVLibrary/TVDatabase/Channel.cs
===================================================================
--- TvEngine3/TVLibrary/TVDatabase/Channel.cs	(revision 28196)
+++ TvEngine3/TVLibrary/TVDatabase/Channel.cs	(working copy)
@@ -26,6 +26,21 @@
 namespace TvDatabase
 {
   /// <summary>
+  /// Enum for channel provider type (Analog/DVBx/WebStream)
+  /// </summary>
+  public enum ChannelProviderType
+  {
+    Analog = 0,  //0
+    ATSC,        //1
+    DVBC,        //2
+    DVBS,        //3
+    DVBT,        //4
+    WebStream,   //5
+    NotUsed,     //6
+    DVBIP        //7
+  }
+
+  /// <summary>
   /// Instances of this class represent the properties and methods of a row in the table <b>Channel</b>.
   /// </summary>
   [TableName("Channel")]
@@ -301,7 +316,7 @@
               ChannelGroup channelGroup = ObjectFactory.GetInstance<ChannelGroup>(stmt.Execute());
               groupNames.Add(channelGroup.GroupName);
             }
-            catch (Exception ex)
+            catch (Exception)
             {
               Log.Error("channelgroup for channel id={0} with channelgroup id={1} does not exist", idChannel,
                         groupMap.IdGroup);
@@ -323,10 +338,16 @@
             sb.AddConstraint(Operator.Equals, "idGroup", groupMap.IdGroup);
 
             stmt = sb.GetStatement();
-
-            RadioChannelGroup channelGroup = ObjectFactory.GetInstance<RadioChannelGroup>(stmt.Execute());
-
-            groupNames.Add(channelGroup.GroupName);
+            try
+            {
+              RadioChannelGroup channelGroup = ObjectFactory.GetInstance<RadioChannelGroup>(stmt.Execute());
+              groupNames.Add(channelGroup.GroupName);
+            }
+            catch (Exception)
+            {
+              Log.Error("radiochannelgroup for channel id={0} with radiochannelgroup id={1} does not exist", idChannel,
+                        groupMap.IdGroup);
+            }
           }
         }
 
@@ -737,7 +758,7 @@
       Remove();
     }
 
-    public bool ContainsChannelType(int channelType)
+    public bool ContainsChannelType(ChannelProviderType channelType)
     {
       foreach (TuningDetail detail in ReferringTuningDetail())
       {
@@ -751,14 +772,18 @@
 
     public bool IsWebstream()
     {
-      IList<TuningDetail> details = ReferringTuningDetail();
+      return HasWebstreamTuningDetails(ReferringTuningDetail());
+    }
+
+    public static bool HasWebstreamTuningDetails(IList<TuningDetail> details)
+    {
       if (details == null)
       {
         return false;
       }
       foreach (TuningDetail detail in details)
       {
-        if (detail.ChannelType == 5)
+        if (detail.ChannelType == ChannelProviderType.WebStream)
         {
           return true;
         }
